diff --git a/src/main/java/net/minecraft/client/gui/GuiContainer.java b/src/main/java/net/minecraft/client/gui/GuiContainer.java
index 2178d5fdd..3efb12233 100644
--- a/src/main/java/net/minecraft/client/gui/GuiContainer.java
+++ b/src/main/java/net/minecraft/client/gui/GuiContainer.java
@@ -10,26 +10,26 @@ import net.minecraft.client.gui.guidebook.search.SearchPage;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.util.helper.GuiItemDragHandler;
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.TileEntityBlastFurnace;
+import net.minecraft.core.block.entity.BlastFurnaceBlockEntity;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.crafting.LookupFuelFurnaceBlast;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryBlastFurnace;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemArmor;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.*;
+import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.menu.*;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotCrafting;
-import net.minecraft.core.player.inventory.slot.SlotCreative;
-import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.player.inventory.slot.ResultSlot;
+import net.minecraft.core.player.inventory.slot.CreativeSlot;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            GuiScreen, EntityPlayerSP, RenderHelper, Container,
+//            GuiScreen, LocalPlayer, RenderHelper, Container,
 //            Slot, InventoryPlayer, RenderItem, StringTranslate,
 //            ItemStack, FontRenderer, RenderEngine, PlayerController,
 //            GameSettings, KeyBinding
@@ -38,12 +38,12 @@ public abstract class GuiContainer extends GuiScreen
 {
 	public int xSize;
 	public int ySize;
-	public Container inventorySlots;
+	public AbstractContainerMenu inventorySlots;
 	GuiTooltip guiTooltip;
 	GuiRenderItem guiRenderItem;
 	public GuiItemDragHandler itemDragHandler;
 
-	public GuiContainer(final Container container)
+	public GuiContainer(final AbstractContainerMenu container)
 	{
 		Minecraft mc = Minecraft.getMinecraft(this);
 		xSize = 176;
@@ -77,12 +77,12 @@ public abstract class GuiContainer extends GuiScreen
 		GL11.glTranslatef(centerX, centerY, 0.0F);
 		drawGuiContainerForegroundLayer();
 		Slot slot = null;
-		for (int i = 0; i < inventorySlots.inventorySlots.size(); i++)
+		for (int i = 0; i < inventorySlots.slots.size(); i++)
 		{
-			final Slot slot1 = inventorySlots.inventorySlots.get(i);
+			final Slot slot1 = inventorySlots.slots.get(i);
 			boolean mouseOver = getIsMouseOverSlot(slot1, mouseX, mouseY);
 			if(!itemDragHandler.isSlotDragged(slot1)) {
-				guiRenderItem.render(slot1.getStack(), slot1.xDisplayPosition, slot1.yDisplayPosition, mouseOver, slot1);
+				guiRenderItem.render(slot1.getItem(), slot1.x, slot1.y, mouseOver, slot1);
 			}
 			if (mouseOver)
 			{
@@ -90,7 +90,7 @@ public abstract class GuiContainer extends GuiScreen
 			}
 		}
 
-		final InventoryPlayer inventoryplayer = mc.thePlayer.inventory;
+		final Inventory inventoryplayer = mc.thePlayer.inventory;
 		ItemStack grabbedItem = inventoryplayer.getHeldItemStack();
 		if(mc.gameSettings.enableItemDragging.value) {
 			itemDragHandler.drawScreen(mouseX, mouseY, partialTick);
@@ -100,26 +100,29 @@ public abstract class GuiContainer extends GuiScreen
 				grabbedItem = grabbedItemOverride;
 			}
 		}
+		GL11.glPopMatrix();
+
+		super.drawScreen(mouseX, mouseY, partialTick);
 
+		GL11.glPushMatrix();
 		if (grabbedItem != null)
 		{
-			GL11.glTranslatef(0.0F, 0.0F, 64F);
+			GL11.glTranslatef(centerX, centerY, 100.0F);
 			guiRenderItem.render(grabbedItem, mouseX - centerX - 8, mouseY - centerY - 8);
 		}
 		GL11.glPopMatrix();
 
-		super.drawScreen(mouseX, mouseY, partialTick);
 		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-		if (inventoryplayer.getHeldItemStack() == null && slot != null && slot.hasStack())
+		if (inventoryplayer.getHeldItemStack() == null && slot != null && slot.hasItem())
 		{
 			boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-			String str = guiTooltip.getTooltipText(slot.getStack(), showDescription, slot);
+			String str = guiTooltip.getTooltipText(slot.getItem(), showDescription, slot);
 			if(str.length() > 0)
 			{
 				guiTooltip.render(str, mouseX, mouseY, 8, -8);
 			}
 		}
-		GL11.glEnable(2929 /*GL_DEPTH_TEST*/);
+		GL11.glEnable(GL11.GL_DEPTH_TEST);
 	}
 
 	public boolean getIsMouseOverSlot(final Slot slot, int i, int j)
@@ -128,14 +131,14 @@ public abstract class GuiContainer extends GuiScreen
 		final int l = (height - ySize) / 2;
 		i -= k;
 		j -= l;
-		return i >= slot.xDisplayPosition - 1 && i < slot.xDisplayPosition + 16 + 1 && j >= slot.yDisplayPosition - 1 && j < slot.yDisplayPosition + 16 + 1;
+		return i >= slot.x - 1 && i < slot.x + 16 + 1 && j >= slot.y - 1 && j < slot.y + 16 + 1;
 	}
 
 	public Slot getSlotAtPosition(final int i, final int j)
 	{
-		for (int k = 0; k < inventorySlots.inventorySlots.size(); k++)
+		for (int k = 0; k < inventorySlots.slots.size(); k++)
 		{
-			final Slot slot = (Slot) inventorySlots.inventorySlots.get(k);
+			final Slot slot = (Slot) inventorySlots.slots.get(k);
 			if (getIsMouseOverSlot(slot, i, j))
 			{
 				return slot;
@@ -162,9 +165,9 @@ public abstract class GuiContainer extends GuiScreen
 		int slotId = getSlotId(mouseX, mouseY);
 		if(slotId >= 0) {
 			if(mc.gameSettings.keyShowRecipe.isKeyboardKey(i)){
-				Slot slot = inventorySlots.inventorySlots.get(slotId);
-				if(slot.hasStack()){
-					String query = "r:"+slot.getStack().getDisplayName()+"!";
+				Slot slot = inventorySlots.slots.get(slotId);
+				if(slot.hasItem()){
+					String query = "r:"+slot.getItem().getDisplayName()+"!";
 					onClosed();
 					mc.thePlayer.closeScreen();
 					PageManager.searchQuery = SearchQuery.resolve(query);
@@ -183,9 +186,9 @@ public abstract class GuiContainer extends GuiScreen
 				}
 			}
 			if(mc.gameSettings.keyShowUsage.isKeyboardKey(i)){
-				Slot slot = inventorySlots.inventorySlots.get(slotId);
-				if(slot.hasStack()) {
-					String query = "u:" + slot.getStack().getDisplayName() + "!";
+				Slot slot = inventorySlots.slots.get(slotId);
+				if(slot.hasItem()) {
+					String query = "u:" + slot.getItem().getDisplayName() + "!";
 					onClosed();
 					mc.thePlayer.closeScreen();
 					PageManager.searchQuery = SearchQuery.resolve(query);
@@ -207,39 +210,39 @@ public abstract class GuiContainer extends GuiScreen
 				boolean ctrl = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
 				int amount = 1;
 				if(ctrl) amount = 64;
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.DROP, new int[] {slotId, amount}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.DROP, new int[] {slotId, amount}, mc.thePlayer);
 			}
 			// Horrifying
 			if (mc.gameSettings.keyHotBarSlot1.isKeyboardKey(i)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 1}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 1}, mc.thePlayer);
 			}
 			if (mc.gameSettings.keyHotBarSlot2.isKeyboardKey(i)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 2}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 2}, mc.thePlayer);
 			}
 			if (mc.gameSettings.keyHotBarSlot3.isKeyboardKey(i)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 3}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 3}, mc.thePlayer);
 			}
 			if (mc.gameSettings.keyHotBarSlot4.isKeyboardKey(i)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 4}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 4}, mc.thePlayer);
 			}
 			if (mc.gameSettings.keyHotBarSlot5.isKeyboardKey(i)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 5}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 5}, mc.thePlayer);
 			}
 			if (mc.gameSettings.keyHotBarSlot6.isKeyboardKey(i)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 6}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 6}, mc.thePlayer);
 			}
 			if (mc.gameSettings.keyHotBarSlot7.isKeyboardKey(i)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 7}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 7}, mc.thePlayer);
 			}
 			if (mc.gameSettings.keyHotBarSlot8.isKeyboardKey(i)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 8}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 8}, mc.thePlayer);
 			}
 			if (mc.gameSettings.keyHotBarSlot9.isKeyboardKey(i)){
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 9}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 9}, mc.thePlayer);
 			}
 
 			if(mc.gameSettings.keySortInventory.isKeyboardKey(i)) {
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.SORT, new int[] {slotId}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.SORT, new int[] {slotId}, mc.thePlayer);
 			}
 		}
 	}
@@ -281,14 +284,14 @@ public abstract class GuiContainer extends GuiScreen
 			// Drop held item
 			InventoryAction action = InventoryAction.DROP_HELD_STACK;
 			if(mouseButton == 1) action = InventoryAction.DROP_HELD_SINGLE;
-			mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, action, null, mc.thePlayer);
+			mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, action, null, mc.thePlayer);
 			return;
 		}
 		
 		if(!mc.thePlayer.getGamemode().consumeBlocks()) {
 			// Duplicate items with middle mouse button
 			if(mouseButton == 2) {
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.CREATIVE_GRAB, new int[] {slotId, 64}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slotId, 64}, mc.thePlayer);
 				return;
 			}
 		}
@@ -317,14 +320,14 @@ public abstract class GuiContainer extends GuiScreen
 		int target = 0; 
 
 		Slot slot = inventorySlots.getSlot(slotId);
-		ItemStack stackInSlot = slot != null ? slot.getStack() : null;
+		ItemStack stackInSlot = slot != null ? slot.getItem() : null;
 		Item itemInSlot = stackInSlot != null ? stackInSlot.getItem() : null;
 		int clickedItemId = stackInSlot != null ? stackInSlot.getItem().id : 0;
 		ItemStack grabbedItem = mc.thePlayer.inventory.getHeldItemStack();
 		
 		if(mouseButton == 1) action = InventoryAction.CLICK_RIGHT;
 		
-		if(slot instanceof SlotCrafting) {
+		if(slot instanceof ResultSlot) {
 			// Crafting behavior
 			if(mc.gameSettings.swapCraftingButtons.value) {
 				if(shiftPressed && ctrlPressed) {
@@ -358,44 +361,44 @@ public abstract class GuiContainer extends GuiScreen
 			}
 		}
 		
-		if(slot instanceof SlotCreative) {
+		if(slot instanceof CreativeSlot) {
 			// Creative slot behavior
 			ItemStack heldItem = mc.thePlayer.inventory.getHeldItemStack();
 			
 			if(heldItem != null) {
 				if(heldItem.canStackWith(stackInSlot)) {
 					if(shiftPressed || ctrlPressed) {
-						mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.CREATIVE_GRAB, new int[] {slot.id, heldItem.getMaxStackSize()}, mc.thePlayer);
+						mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slot.index, heldItem.getMaxStackSize()}, mc.thePlayer);
 					}else {
-						mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.CREATIVE_GRAB, new int[] {slot.id, heldItem.stackSize + 1}, mc.thePlayer);
+						mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slot.index, heldItem.stackSize + 1}, mc.thePlayer);
 					}
 				}else {
-					mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.CREATIVE_GRAB, new int[] {slot.id, 0}, mc.thePlayer);
+					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slot.index, 0}, mc.thePlayer);
 				}
 			}else {
 				if(shiftPressed || ctrlPressed) {
 					int amount = 1;
 					if(shiftPressed && stackInSlot != null) amount = stackInSlot.getMaxStackSize();
-					mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.CREATIVE_MOVE, new int[] {slot.id, amount}, mc.thePlayer);
+					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_MOVE, new int[] {slot.index, amount}, mc.thePlayer);
 				}else {
-					mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.CREATIVE_GRAB, new int[] {slot.id, 1}, mc.thePlayer);
+					mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_GRAB, new int[] {slot.index, 1}, mc.thePlayer);
 				}
 			}
 			return;
 		}
 
-		if(inventorySlots instanceof ContainerPlayer) {
-			if(itemInSlot instanceof ItemArmor || itemInSlot == Item.armorQuiver || itemInSlot == Item.armorQuiverGold || itemInSlot == Item.armorBootsIceskates) {
-				// Check for instanceof ItemArmor instead of canPutStackInSlot
+		if(inventorySlots instanceof InventoryMenu) {
+			if(itemInSlot instanceof IArmorItem) {
+				// Check for instanceof ArmorItem instead of canPutStackInSlot
 				// Pumpkins should not go into the armor slot when pressing shift
 				target = 2; // Into the armor slots
 			}
 		}
-		if(inventorySlots instanceof ContainerFurnace) {
+		if(inventorySlots instanceof FurnaceMenu) {
 			// Furnace behavior
-			ContainerFurnace furnace = (ContainerFurnace) inventorySlots;
+			FurnaceMenu furnace = (FurnaceMenu) inventorySlots;
 			
-			boolean isBlastFurnace = furnace.tileEntity instanceof TileEntityBlastFurnace;
+			boolean isBlastFurnace = furnace.furnace instanceof BlastFurnaceBlockEntity;
 			boolean isFuel, isIngredient = false;
 			
 			if(isBlastFurnace) {
@@ -422,31 +425,31 @@ public abstract class GuiContainer extends GuiScreen
 				target = 2; // Into the fuel slot
 			}
 		}
-		if(inventorySlots instanceof ContainerTrommel) {
+		if(inventorySlots instanceof TrommelMenu) {
 			if(LookupFuelFurnace.instance.getFuelYield(clickedItemId) > 0) {
 				target = 2; // Into the fuel slot
 			}else {
 				target = 1; // Into the item slots
 			}
 		}
-		if(inventorySlots instanceof ContainerWorkbench || inventorySlots instanceof ContainerPlayer) {
+		if(inventorySlots instanceof CraftingMenu || inventorySlots instanceof InventoryMenu) {
 			// Move items into crafting by holding alt
 			
 			if(altPressed) target = 1; // Into the crafting grid
 		}
-		if(inventorySlots instanceof ContainerPlayerCreative) {
+		if(inventorySlots instanceof CreativeInventoryMenu) {
 			// Delete items by holding alt in the creative inventory
 			
 			if(altPressed) {
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.CREATIVE_DELETE, new int[] {slot.id}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.CREATIVE_DELETE, new int[] {slot.index}, mc.thePlayer);
 				return;
 			}
 		}
 		
 		// Equip armor
-		if(slot != null && itemInSlot != null && itemInSlot instanceof ItemArmor) {
+		if(slot != null && itemInSlot instanceof IArmorItem) {
 			if(mouseButton == 1 && shiftPressed) {
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.EQUIP_ARMOR, new int[] {slot.id}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.EQUIP_ARMOR, new int[] {slot.index}, mc.thePlayer);
 				return;
 			}
 		}
@@ -454,7 +457,7 @@ public abstract class GuiContainer extends GuiScreen
 		// Inventory Interactions (Grabbed Item)
 		if(slot != null && slot.allowItemInteraction() && grabbedItem != null && grabbedItem.getItem().hasInventoryInteraction()) {
 			if(mouseButton == 1) {
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.INTERACT_GRABBED, new int[] {slot.id}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.INTERACT_GRABBED, new int[] {slot.index}, mc.thePlayer);
 				return;
 			}
 		}
@@ -462,13 +465,13 @@ public abstract class GuiContainer extends GuiScreen
 		// Inventory Interactions (Clicked Item)
 		if(slot != null && stackInSlot != null && slot.allowItemInteraction() && stackInSlot.getItem().hasInventoryInteraction()) {
 			if(mouseButton == 1) {
-				mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, InventoryAction.INTERACT_SLOT, new int[] {slot.id}, mc.thePlayer);
+				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.INTERACT_SLOT, new int[] {slot.index}, mc.thePlayer);
 				return;
 			}
 		}
 		
 		int[] args = new int[] { slotId, target };
-		mc.playerController.handleInventoryMouseClick(inventorySlots.windowId, action, args, mc.thePlayer);
+		mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, action, args, mc.thePlayer);
 	}
 	public void controllerInput(ControllerInput controller){
 		Slot slot = controller.getSlotAtCursor(this);
@@ -482,18 +485,18 @@ public abstract class GuiContainer extends GuiScreen
 			if(controller.digitalPad.right.pressedThisFrame()) {
 				Slot slot3 = null;
 				//Get Next Slot to the right
-				for(Slot slot2 : inventorySlots.inventorySlots) {
-					if(slot2.xDisplayPosition > slot.xDisplayPosition && Math.abs(slot2.yDisplayPosition - slot.yDisplayPosition) < 12) {
-						if(slot3 == null || slot2.xDisplayPosition < slot3.xDisplayPosition) {
+				for(Slot slot2 : inventorySlots.slots) {
+					if(slot2.x > slot.x && Math.abs(slot2.y - slot.y) < 12) {
+						if(slot3 == null || slot2.x < slot3.x) {
 							slot3 = slot2;
 						}
 					}
 				}
 				if(slot3 == null) {
 					//Get First Slot on the left
-					for(Slot slot2 : inventorySlots.inventorySlots) {
-						if(Math.abs(slot2.yDisplayPosition - slot.yDisplayPosition) < 12) {
-							if(slot3 == null || slot2.xDisplayPosition < slot3.xDisplayPosition) {
+					for(Slot slot2 : inventorySlots.slots) {
+						if(Math.abs(slot2.y - slot.y) < 12) {
+							if(slot3 == null || slot2.x < slot3.x) {
 								slot3 = slot2;
 							}
 						}
@@ -504,18 +507,18 @@ public abstract class GuiContainer extends GuiScreen
 			if(controller.digitalPad.left.pressedThisFrame()) {
 				Slot slot3 = null;
 				//Get Next Slot to the left
-				for(Slot slot2 : this.inventorySlots.inventorySlots) {
-					if(slot2.xDisplayPosition < slot.xDisplayPosition && Math.abs(slot2.yDisplayPosition - slot.yDisplayPosition) < 12) {
-						if(slot3 == null || slot2.xDisplayPosition > slot3.xDisplayPosition) {
+				for(Slot slot2 : this.inventorySlots.slots) {
+					if(slot2.x < slot.x && Math.abs(slot2.y - slot.y) < 12) {
+						if(slot3 == null || slot2.x > slot3.x) {
 							slot3 = slot2;
 						}
 					}
 				}
 				if(slot3 == null) {
 					//Get First Slot on the right
-					for(Slot slot2 : this.inventorySlots.inventorySlots) {
-						if(Math.abs(slot2.yDisplayPosition - slot.yDisplayPosition) < 12) {
-							if(slot3 == null || slot2.xDisplayPosition > slot3.xDisplayPosition) {
+					for(Slot slot2 : this.inventorySlots.slots) {
+						if(Math.abs(slot2.y - slot.y) < 12) {
+							if(slot3 == null || slot2.x > slot3.x) {
 								slot3 = slot2;
 							}
 						}
@@ -526,18 +529,18 @@ public abstract class GuiContainer extends GuiScreen
 			if(controller.digitalPad.up.pressedThisFrame()) {
 				Slot slot3 = null;
 				//Get Next Slot up
-				for(Slot slot2 : this.inventorySlots.inventorySlots) {
-					if(slot2.yDisplayPosition < slot.yDisplayPosition && Math.abs(slot2.xDisplayPosition - slot.xDisplayPosition) < 12) {
-						if(slot3 == null || slot2.yDisplayPosition > slot3.yDisplayPosition) {
+				for(Slot slot2 : this.inventorySlots.slots) {
+					if(slot2.y < slot.y && Math.abs(slot2.x - slot.x) < 12) {
+						if(slot3 == null || slot2.y > slot3.y) {
 							slot3 = slot2;
 						}
 					}
 				}
 				if(slot3 == null) {
 					//Get First Slot on the bottom
-					for(Slot slot2 : this.inventorySlots.inventorySlots) {
-						if(Math.abs(slot2.xDisplayPosition - slot.xDisplayPosition) < 12) {
-							if(slot3 == null || slot2.yDisplayPosition > slot3.yDisplayPosition) {
+					for(Slot slot2 : this.inventorySlots.slots) {
+						if(Math.abs(slot2.x - slot.x) < 12) {
+							if(slot3 == null || slot2.y > slot3.y) {
 								slot3 = slot2;
 							}
 						}
@@ -548,18 +551,18 @@ public abstract class GuiContainer extends GuiScreen
 			if(controller.digitalPad.down.pressedThisFrame()) {
 				Slot slot3 = null;
 				//Get Next Slot down
-				for(Slot slot2 : this.inventorySlots.inventorySlots) {
-					if(slot2.yDisplayPosition > slot.yDisplayPosition && Math.abs(slot2.xDisplayPosition - slot.xDisplayPosition) < 12) {
-						if(slot3 == null || slot2.yDisplayPosition < slot3.yDisplayPosition) {
+				for(Slot slot2 : this.inventorySlots.slots) {
+					if(slot2.y > slot.y && Math.abs(slot2.x - slot.x) < 12) {
+						if(slot3 == null || slot2.y < slot3.y) {
 							slot3 = slot2;
 						}
 					}
 				}
 				if(slot3 == null) {
 					//Get First Slot on the top
-					for(Slot slot2 : this.inventorySlots.inventorySlots) {
-						if(Math.abs(slot2.xDisplayPosition - slot.xDisplayPosition) < 12) {
-							if(slot3 == null || slot2.yDisplayPosition < slot3.yDisplayPosition) {
+					for(Slot slot2 : this.inventorySlots.slots) {
+						if(Math.abs(slot2.x - slot.x) < 12) {
+							if(slot3 == null || slot2.y < slot3.y) {
 								slot3 = slot2;
 							}
 						}
@@ -586,7 +589,7 @@ public abstract class GuiContainer extends GuiScreen
 		boolean flag = x < x2 || y < y2 || x >= x2 + xSize || y >= y2 + ySize;
 		int slotId = -1;
 		if(slot != null) {
-			slotId = slot.id;
+			slotId = slot.index;
 		}
 		if(flag) {
 			slotId = -999;
@@ -603,7 +606,7 @@ public abstract class GuiContainer extends GuiScreen
 		}
 		else
 		{
-			mc.playerController.handleCloseInventory(inventorySlots.windowId, mc.thePlayer);
+			mc.playerController.handleCloseInventory(inventorySlots.containerId, mc.thePlayer);
 			return;
 		}
 	}
